Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3481)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3483)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! bugfix: wrong locations of netCDF directives fixed
+! 
+! 3467 2018-10-30 19:05:21Z suehring
 ! Enabled PARAMETRIZED mode for default surfaces when LSM is not applied but 
 ! salsa is used
@@ -85,11 +88,9 @@
 
 #if defined ( __netcdf )
+    USE NETCDF
+#endif
 
     USE netcdf_data_input_mod,                                                  &
        ONLY: chem_emis_att_type, chem_emis_val_type
-
-    USE NETCDF
-
-#endif
 
     USE date_and_time_mod,                                                      &
@@ -192,5 +193,5 @@
 
     !> Boltzmann constant:
-    REAL, PARAMETER        ::  kbolz = 1.38066e-23_wp    ! J/K
+    REAL(wp), PARAMETER     ::  kbolz = 1.38066e-23_wp    ! J/K
 
     !> Inverse Reference Pressure (1/Pa)    
@@ -758,6 +759,4 @@
  SUBROUTINE chem_emissions_init(emt_att,emt,nspec_out)
 
-#if defined( __netcdf )
-
     USE surface_mod,                                                           &
        ONLY:  surf_lsm_h,surf_def_h,surf_usm_h
@@ -868,7 +867,4 @@
   ENDIF    
 
-#endif
-
-
  END SUBROUTINE chem_emissions_init
 
@@ -899,6 +895,4 @@
 
  IMPLICIT NONE
-
-#if defined( __netcdf )
   
     !--- IN/OUT
@@ -1716,6 +1710,4 @@
 
 
-#endif
-
  END SUBROUTINE chem_emissions_setup
 
Index: palm/trunk/SOURCE/cpulog_mod.f90
===================================================================
--- palm/trunk/SOURCE/cpulog_mod.f90	(revision 3481)
+++ palm/trunk/SOURCE/cpulog_mod.f90	(revision 3483)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! output format limited to a maximum line length of 80
+! 
+! 3229 2018-09-04 15:05:36Z sward
 ! Bugfix in maximum time spent per log point: PE 0 was beeing ignored.
 ! 
@@ -587,7 +590,7 @@
    101 FORMAT (/'special measures:'/ &
                &'-----------------------------------------------------------', &
-               &'------------------------')
-
-   102 FORMAT (A25,2X,F9.3,2X,F7.2,1X,I7,3(1X,F9.3))
+               &'---------------------')
+
+   102 FORMAT (A25,2X,F9.3,2X,F7.2,1X,I7,2(1X,F9.3),1X,F5.2)
    103 FORMAT (/'Barriers are set in front of collective operations')
    104 FORMAT (/'No barriers are set in front of collective operations')
@@ -595,12 +598,12 @@
    106 FORMAT (/'Exchange of ghostpoints via MPI_ISEND/MPI_IRECV')
    107 FORMAT (//)
-   110 FORMAT ('-------------------------------------------------------------',     &
-               &'---------'//&
-               &'place:                              mean        counts      min  ',&
-               &'     max       rms'/ &
-               &'                                sec.      %                sec. ', &
-               &'     sec.      sec.'/  &
-               &'-----------------------------------------------------------',      &
-               &'------------------------')
+   110 FORMAT ('------------------------------------------------------------', &
+               &'----------'//                                                 &
+               &'place:                              mean        counts     ', &
+               &' min       max    rms'/                                       &
+               &'                                sec.      %                ', &
+               &'sec.      sec.   sec.'/                                       &
+               &'-----------------------------------------------------------', &
+               &'---------------------')
    111 FORMAT (/'Barriers are set at beginning (start/continue) of measurements')
 
Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3481)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3483)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix: misplaced directives for netCDF fixed
+! 
+! 3474 2018-10-30 21:07:39Z kanani
 ! Add UV exposure model input (Schrempf)
 ! 
@@ -4944,6 +4947,4 @@
      SUBROUTINE netcdf_data_input_get_dimension_length( id, dim_len,           &
                                                         variable_name )
-#if defined( __netcdf )
-
        USE pegrid
 
@@ -4957,4 +4958,5 @@
        INTEGER(iwp)                ::  id_dim           !< dimension id
 
+#if defined( __netcdf )
 !
 !--    First, inquire dimension ID
Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3481)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3483)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfix: directives added to allow compilation without netCDF
+! 
+! 3481 2018-11-02 09:14:13Z raasch
 ! temporary variable cc introduced to circumvent a possible Intel18 compiler bug
 ! related to contiguous/non-contguous pointer/target attributes
@@ -1410,5 +1413,5 @@
         ONLY:  zu
  
-    USE NETCDF
+!    USE NETCDF
     
     USE netcdf_data_input_mod,                                                 &
@@ -1469,4 +1472,5 @@
 !
 !--    Read input profiles from PIDS_SALSA    
+#if defined( __netcdf )
 !    
 !--    Location-dependent size distributions and compositions.      
@@ -1560,4 +1564,5 @@
           CALL message( 'salsa_mod: aerosol_init', 'SA0032', 1, 2, 0, 6, 0 )                
        ENDIF   ! netcdf_extend   
+#endif
  
     ELSEIF ( isdtyp == 0 )  THEN
@@ -1610,4 +1615,5 @@
 !
 !--    Read input profiles from PIDS_CHEM    
+#if defined( __netcdf )
 !    
 !--    Location-dependent size distributions and compositions.      
@@ -1661,4 +1667,6 @@
           CALL message( 'salsa_mod: aerosol_init', 'SA0033', 1, 2, 0, 6, 0 )                
        ENDIF   ! netcdf_extend     
+#endif
+
     ENDIF
 
Index: palm/trunk/SOURCE/surface_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_output_mod.f90	(revision 3481)
+++ palm/trunk/SOURCE/surface_output_mod.f90	(revision 3483)
@@ -25,7 +25,10 @@
 ! -----------------
 ! $Id$
+! bugfix: missed directives for MPI added
+! 
+! 3421 2018-10-24 18:39:32Z gronemeier
 ! Add output variables
 ! Write data into binary file
-! Initial implenentation from Klaus Ketelsen and Matthias Suehring
+! Initial implementation from Klaus Ketelsen and Matthias Suehring
 !
 ! 3420 2018-10-24 17:30:08Z gronemeier
@@ -796,5 +799,7 @@
                WRITE ( 25+av )  surfaces%polygons
             ENDIF
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
+#endif
             first_output(av) = .TRUE.
          ENDDO
@@ -808,5 +813,7 @@
             WRITE ( 25+av )  simulated_time
          ENDIF
+#if defined( __parallel )
          CALL MPI_BARRIER( comm2d, ierr )
+#endif
       ENDDO
 
@@ -1941,5 +1948,7 @@
                WRITE ( 25+av )  surfaces%var_out
             ENDIF
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
+#endif
          ENDDO
 