Index: palm/trunk/SCRIPTS/palmrungui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui	(revision 3486)
+++ palm/trunk/SCRIPTS/palmrungui	(revision 3487)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Renamed options -d and -h to -r and -c.
+# 
+# 2825 2018-02-20 21:48:27Z maronga
 # Adjusted to work with newest version of palmrun
 # 
@@ -228,5 +231,5 @@
 
             if ( len(matchitems) == 0 ):
-                listitem = filter(None,listitem.split(" -d"))[1]
+                listitem = filter(None,listitem.split(" -r"))[1]
                 listitem = filter(None,listitem.split(" -"))[0]
                 listitem = listitem.replace(" ",""); 
@@ -277,5 +280,5 @@
 
             # Change palmrunline accordingly
-            self.change_commandline("d","")
+            self.change_commandline("r","")
             self.change_commandline("a","")
             return
@@ -311,5 +314,5 @@
         while i>=1:
             listitem = history[i-1][17:len(history[i-1])-1]
-            listitem = filter(None,listitem.split(" -d"))[1]
+            listitem = filter(None,listitem.split(" -r"))[1]
             listitem = filter(None,listitem.split(" -"))[0]
             listitem = listitem.replace(" ","");                
@@ -342,5 +345,5 @@
     
         if ( drop_job == "Restart run" or drop_job == "Restart run (coupled atmosphere ocean)"):
-           self.change_commandline("d","")
+           self.change_commandline("r","")
 
         # Check of ocean runs
@@ -371,6 +374,6 @@
         param = splitline[1].split("-")
     
-        # Change in parameter "d" (jobname)
-        if (id_str == "d"):
+        # Change in parameter "r" (jobname)
+        if (id_str == "r"):
             filename = str(self.group_job.findChild(QtGui.QLineEdit,"line_jobname").text())
             s = filename.split("JOBS/") 
@@ -390,5 +393,5 @@
                 self.menuBar.findChild(QtGui.QMenu,"menuStart").actions()[3].setEnabled(False)
                 self.group_advanced.setEnabled(False)
-                self.delete_commandline("d")
+                self.delete_commandline("r")
                 self.change_commandline("a","remove")
                 self.group_job.findChild(QtGui.QLabel,"label_usercode").setText("")
@@ -535,9 +538,9 @@
         if ( self.sender() == self.group_execution.findChild(QtGui.QLineEdit, "line_host") ):
             tmptext = self.group_execution.findChild(QtGui.QLineEdit,"line_host").text()
-            self.change_commandline("h",tmptext)
+            self.change_commandline("c",tmptext)
 
         elif ( self.sender() == self.group_job.findChild(QtGui.QLineEdit, "line_jobname") ):
             tmptext = self.group_job.findChild(QtGui.QLineEdit,"line_jobname").text()
-            self.change_commandline("d",tmptext)
+            self.change_commandline("r",tmptext)
 
         elif ( self.sender() == self.group_execution.findChild(QtGui.QLineEdit,"line_q")):
@@ -820,5 +823,5 @@
 
             # Check for suitable switch
-            if ( parameter == "d"):
+            if ( parameter == "r"):
               
                 if ( options != ""):
@@ -829,5 +832,5 @@
                     nojob = True 
                 
-            elif ( parameter == "h"):
+            elif ( parameter == "c"):
                 self.group_execution.findChild(QtGui.QLineEdit,"line_host").setText(options) 
              
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 3486)
+++ palm/trunk/SOURCE/palm.f90	(revision 3487)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Updates version to 6.0
+! 
+! 3484 2018-11-02 14:41:25Z hellstea
 ! pmci_ensure_nest_mass_conservation removed permanently
 ! 
@@ -324,5 +327,5 @@
     INTEGER(iwp)     ::  i               !< loop counter for blocked I/O
 
-    version = 'PALM 5.0'
+    version = 'PALM 6.0'
     user_interface_required_revision = 'r3240'
 
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive1/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive1/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive1/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_phstat/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_phstat/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_phstat/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.f90	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.f90	(revision 3487)
@@ -46,6 +46,4 @@
 ! Current revisions:
 ! ------------------
-! forkel June 2018: qvap,fakt added
-! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
 ! 
 ! 
@@ -53,4 +51,9 @@
 ! -----------------
 ! $Id: module_header 2460 2017-09-13 14:47:48Z forkel $
+! forkel June 2018: qvap,fakt added
+! forkel June 2018: reset case in  Initialize,Integrate,Update_rconst
+! 
+! 
+! 2460 2017-09-13 14:47:48Z forkel
 !
 ! forkel Sept. 2017: Variables for photolyis added
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh	(revision 3486)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh	(revision 3487)
@@ -24,9 +24,12 @@
 # Current revisions:
 # ------------------
-# Some correctetion of comments
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$ 
+# Some correctetion of comments
+# 
+# 3458 2018-10-30 14:51:23Z kanani
 #  passed $MECH insted of $DEFDIR to kpp4palm.ksh                   forkel  25. Sept. 2018
 #  re-activaded  choice of deindexing method and vector mode        forkel  June 2018