Index: palm/trunk/SCRIPTS/palmbuild
===================================================================
--- palm/trunk/SCRIPTS/palmbuild	(revision 3533)
+++ palm/trunk/SCRIPTS/palmbuild	(revision 3534)
@@ -27,4 +27,8 @@
 # -----------------
 # $Id$
+# build of inifor added,
+# ssh-calls rearranged to avoid output of system/user-profile messages
+# 
+# 3523 2018-11-13 16:09:31Z suehring
 # Enable compilation of post-processing tool for surface output - interface
 # for posix conform sytemcalls is implemented.
@@ -509,7 +513,8 @@
  cp -p  ../UTIL/agent_preprocessing/agent_preprocessing.f90  .
  cp -p  ../UTIL/surface_output_processing/surface_output_to_vtk.f90  .
+ cp -p  ../UTIL/inifor/src/inifor*f90  .
  cp -p  ../UTIL/Makefile_utilities  .
  tar -cf  ${program_name}_sources.tar  Makefile*  *.$suf
- rm  combine_plot_fields.f90  compare_palm_logs.f90 agent_preprocessing.f90 Makefile_utilities surface_output_to_vtk.f90
+ rm  combine_plot_fields.f90  compare_palm_logs.f90 agent_preprocessing.f90 Makefile_utilities surface_output_to_vtk.f90 inifor*f90
 
 
@@ -528,8 +533,10 @@
           echo " "
           echo "  *** copying \"${program_name}_sources.tar\" to \"${remote_ip}:${make_depository}/\" "
-          echo "[[ ! -d ${make_depository} ]]  &&  (echo \"  *** ${make_depository} will be created\"; mkdir -p  ${make_depository})"  |  ssh  -q  $ssh_key ${remote_username}@${remote_ip}  2>&1
+###          echo "[[ ! -d ${make_depository} ]]  &&  (echo \"  *** ${make_depository} will be created\"; mkdir -p  ${make_depository})"  |  ssh  -q  $ssh_key ${remote_username}@${remote_ip}  2>&1
+          ssh  -q  $ssh_key ${remote_username}@${remote_ip}  "[[ ! -d ${make_depository} ]]  &&  (echo \"  *** ${make_depository} will be created\"; mkdir -p  ${make_depository})"  2>&1
           scp  $ssh_key ${source_path}/${program_name}_sources.tar  ${remote_username}@${remote_ip}:${make_depository}/${program_name}_sources.tar
        else
-          echo "[[ ! -d ${make_depository} ]]  &&  mkdir -p  ${make_depository}"  |  ssh  -q  $ssh_key ${remote_username}@${remote_ip}  2>&1
+###          echo "[[ ! -d ${make_depository} ]]  &&  mkdir -p  ${make_depository}"  |  ssh  -q  $ssh_key ${remote_username}@${remote_ip}  2>&1
+          ssh  -q  $ssh_key ${remote_username}@${remote_ip}  "[[ ! -d ${make_depository} ]]  &&  mkdir -p  ${make_depository}"  2>&1
           scp  $ssh_key ${source_path}/${program_name}_sources.tar  ${remote_username}@${remote_ip}:${make_depository}/${program_name}_sources.tar  >  /dev/null
        fi
@@ -543,5 +550,6 @@
           echo "  *** untar previous update on remote host, if existing"
        fi
-       echo "cd ${make_depository}; [[ -f ${program_name}_current_version.tar ]]  &&  tar -xf  ${program_name}_current_version.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+###       echo "cd ${make_depository}; [[ -f ${program_name}_current_version.tar ]]  &&  tar -xf  ${program_name}_current_version.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "cd ${make_depository}; [[ -f ${program_name}_current_version.tar ]]  &&  tar -xf  ${program_name}_current_version.tar"  2>&1
 
 
@@ -551,5 +559,6 @@
           echo "  *** untar current sources on remote host"
        fi
-       echo  "cd ${make_depository}; tar -xf  ${program_name}_sources.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+###       echo  "cd ${make_depository}; tar -xf  ${program_name}_sources.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "cd ${make_depository}; tar -xf  ${program_name}_sources.tar"  2>&1
 
 
@@ -567,4 +576,5 @@
        make_call_string="make  -f Makefile_utilities  $make_options  F90=$compiler_name  F90_SER=$compiler_name_ser  COPT=\"$cpp_options\"  F90FLAGS=\"$compiler_options\"  LDFLAGS=\"$linker_options\" "
        echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
+###       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
        if [[ $(grep -c MAKE_ERROR ${configuration_identifier}_last_make_protocol) != 0 ]]
@@ -606,4 +616,5 @@
        make_call_string="make  $make_options  PROG=$program_name  F90=$compiler_name  COPT=\"$cpp_options\"  F90FLAGS=\"$compiler_options\"  LDFLAGS=\"$linker_options\" "
        echo "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
+###       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${make_depository}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
        if [[ $(grep -c MAKE_ERROR ${configuration_identifier}_last_make_protocol) != 0 ]]
@@ -638,5 +649,6 @@
           printf "\n  *** tar update on remote host ..."
        fi
-       echo  "cd ${make_depository}; chmod u+w *; tar -cf  ${program_name}_current_version.tar  ${program_name}  *.f90 *.o *.mod *.x"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+###       echo  "cd ${make_depository}; chmod u+w *; tar -cf  ${program_name}_current_version.tar  ${program_name}  *.f90 *.o *.mod *.x"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "cd ${make_depository}; chmod u+w *; tar -cf  ${program_name}_current_version.tar  ${program_name}  *.f90 *.o *.mod *.x"  2>&1
 
 
@@ -649,5 +661,6 @@
           # FIRST CHECK, IF COMPILED SOURCES FOR THIS RUN IDENTIFIER EXISTS
           # AND ASK, IF THEY SHALL BE USED
-       echo  "[[ -d ${fast_io_catalog}/${sources_for_run_catalog} ]]  &&  echo sources for run found" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1  >  ${configuration_identifier}_last_make_protocol
+###       echo  "[[ -d ${fast_io_catalog}/${sources_for_run_catalog} ]]  &&  echo sources for run found" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1  >  ${configuration_identifier}_last_make_protocol
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "[[ -d ${fast_io_catalog}/${sources_for_run_catalog} ]]  &&  echo sources for run found"  2>&1  >  ${configuration_identifier}_last_make_protocol
        if [[ $(grep -c "sources for run found" ${configuration_identifier}_last_make_protocol) != 0  &&  $use_existing_sources_folder = true ]]
        then
@@ -663,5 +676,6 @@
           printf "\n  *** copy MAKE_DEPOSITORY_${configuration_identifier} on remote host to $sources_for_run_catalog \n"
        fi
-       echo  "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}; mkdir -p ${fast_io_catalog}/${sources_for_run_catalog}; cp ${make_depository}/${program_name}_current_version.tar  ${fast_io_catalog}/${sources_for_run_catalog}; cd ${fast_io_catalog}/${sources_for_run_catalog}; tar xf ${program_name}_current_version.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+###       echo  "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}; mkdir -p ${fast_io_catalog}/${sources_for_run_catalog}; cp ${make_depository}/${program_name}_current_version.tar  ${fast_io_catalog}/${sources_for_run_catalog}; cd ${fast_io_catalog}/${sources_for_run_catalog}; tar xf ${program_name}_current_version.tar"  |  ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  2>&1
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}; mkdir -p ${fast_io_catalog}/${sources_for_run_catalog}; cp ${make_depository}/${program_name}_current_version.tar  ${fast_io_catalog}/${sources_for_run_catalog}; cd ${fast_io_catalog}/${sources_for_run_catalog}; tar xf ${program_name}_current_version.tar"  2>&1
 
 
@@ -686,5 +700,6 @@
              echo "  *** execute \"make\" on remote host"
           fi
-          echo "$login_init_cmd $module_commands cd ${fast_io_catalog}/${sources_for_run_catalog}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
+###          echo "$login_init_cmd $module_commands cd ${fast_io_catalog}/${sources_for_run_catalog}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1 | tee ${configuration_identifier}_last_make_protocol
+          ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "$login_init_cmd $module_commands cd ${fast_io_catalog}/${sources_for_run_catalog}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
           if [[ $(grep -c MAKE_ERROR ${configuration_identifier}_last_make_protocol) != 0 ]]
@@ -706,10 +721,12 @@
                 if [[ $answer = k ]]
                 then
-                   echo "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1
+###                   echo "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1
+                   ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}"  2>&1
                    locat=user_abort; exit
                 fi
              else
                    # ABORT ANYWAY
-                echo "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1
+###                echo "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1
+                ssh  -q  $ssh_key  ${remote_username}@${remote_ip}  "rm -rf ${fast_io_catalog}/${sources_for_run_catalog}"  2>&1
                 locat=user_abort; exit
              fi
@@ -814,4 +831,5 @@
        else
           cp agent_preprocessing $source_path/../SCRIPTS/.
+          cp inifor $source_path/../SCRIPTS/.
        fi
 
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3533)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3534)
@@ -27,4 +27,9 @@
 # -----------------
 # $Id$
+# batch_scp for sending back the job protocol file is called via login-node if
+# a login-node has been set in the config-file
+# ssh-calls rearranged to avoid output of system/user-profile messages
+# 
+# 3505 2018-11-08 09:14:30Z raasch
 # job folders are created in case that they do not exist
 # 
@@ -1825,5 +1830,6 @@
        line=`grep %base_directory $config_file`
        make_depository=`echo $line | cut -d" " -s -f2`/MAKE_DEPOSITORY_${configuration_identifier}
-       echo  "[[ ! -d ${make_depository} ]]  &&  echo depository not found" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1  | tee ${configuration_identifier}_last_make_protokoll
+###       echo  "[[ ! -d ${make_depository} ]]  &&  echo depository not found" | ssh  -q  $ssh_key  ${remote_username}@${remote_ip} 2>&1  | tee ${configuration_identifier}_last_make_protokoll
+       ssh  -q  $ssh_key  ${remote_username}@${remote_ip} "[[ ! -d ${make_depository} ]]  &&  echo depository not found" 2>&1  | tee ${configuration_identifier}_last_make_protokoll
 
        if [[ $(grep -c "depository not found" ${configuration_identifier}_last_make_protokoll) != 0 ]]
@@ -2569,5 +2575,6 @@
                 if [[ "$remote_loginnode" != "" ]]
                 then
-                   echo "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}"  |  ssh -q $remote_username@$remote_loginnode
+###                   echo "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}"  |  ssh -q $remote_username@$remote_loginnode
+                   ssh -q $remote_username@$remote_loginnode  "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}"
                 else
                    batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}
@@ -2758,7 +2765,8 @@
           if [[ "$remote_loginnode" != "" ]]
           then
-             echo "echo \" PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc\" |  ssh -q $SSH_PORTOPT  $local_username@$return_address  " |  ssh -q $remote_username@$remote_loginnode  |  tee palmrun_restart.log
+             ssh -q $remote_username@$remote_loginnode  "ssh -q $SSH_PORTOPT  $local_username@$return_address \" PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc\" " |  tee palmrun_restart.log
           else
-             echo \" PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc\" |  ssh -q $SSH_PORTOPT  $local_username@$return_address  |  tee palmrun_restart.log
+###             echo \" PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc\" |  ssh -q $SSH_PORTOPT  $local_username@$return_address  |  tee palmrun_restart.log
+             ssh -q $SSH_PORTOPT  $local_username@$return_address  " PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc" |  tee palmrun_restart.log
           fi
 
@@ -2898,8 +2906,13 @@
 
        echo "set -x"                               >>  $jobfile
-       echo "${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote  \"$local_jobcatalog\"  ${configuration_identifier}_${run_identifier}"  >>  $jobfile
+       if [[ "$remote_loginnode" != "" ]]
+       then
+          echo "ssh -q $remote_username@$remote_loginnode  \"cd ${remote_jobcatalog}; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote \\\"$local_jobcatalog\\\"  ${configuration_identifier}_${run_identifier}\" "  >> $jobfile
+       else
+          echo "${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote  \"$local_jobcatalog\"  ${configuration_identifier}_${run_identifier}"  >>  $jobfile
+       fi
        echo "%%END%%"                              >>  $jobfile
        echo "echo \" *** submitting job for transfering the job protocol file to $local_ip\" "  >>  $jobfile
-       echo "$submit_command  $scpjob_file"        >>  $jobfile
+       echo "$submit_command  $scpjob_file"     >>  $jobfile
        echo "rm $scpjob_file"                      >>  $jobfile
        echo "rm -rf $job_transfer_protocol_file"   >>  $jobfile
@@ -2986,5 +2999,6 @@
 
              # CREATE REMOTE JOB FOLDER, IF IT DOES NOT EXIST
-          echo "[[ ! -d $remote_jobcatalog ]]  &&  mkdir $remote_jobcatalog"  |  ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  2>&1
+###          echo "[[ ! -d $remote_jobcatalog ]]  &&  mkdir $remote_jobcatalog"  |  ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  2>&1
+          ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  "[[ ! -d $remote_jobcatalog ]]  &&  mkdir $remote_jobcatalog"  2>&1
 
              # COPY THE JOB FILE 
@@ -2999,7 +3013,9 @@
           if [[ $do_trace = true ]]
           then
-             echo "     cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}  |  ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  2>&1"
+###             echo "     cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}  |  ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  2>&1"
+             echo "     ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  \"cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}\"  2>&1"
           fi
           echo "cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}"  |  ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  2>&1
+###          ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  "cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}"  2>&1
 
        elif [[ $create_batch_job = true ]]
Index: palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- palm/trunk/SOURCE/poismg_mod.f90	(revision 3533)
+++ palm/trunk/SOURCE/poismg_mod.f90	(revision 3534)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unnecessary check eliminated
+! 
+! 3524 2018-11-14 13:36:44Z raasch
 ! mpi_abort arguments replaced to avoid compile errors
 ! 
@@ -1189,13 +1192,4 @@
              ENDDO
 !
-!++          ATTENTION: Check reason for this error. Remove it or replace WRITE
-!++                     by PALM message
-#if defined ( __parallel )
-             IF ( ind /= ind_even_odd )  THEN
-                WRITE (0,*) 'ERROR ==> illegal ind_even_odd ',ind,ind_even_odd,l
-                CALL MPI_ABORT( MPI_COMM_WORLD, 9999, ierr )
-             ENDIF
-#endif
-!
 !--          Sort the data with odd k index
              DO  k = nzb+1, nzt_mg(l)+1, 2
Index: palm/trunk/UTIL/Makefile_utilities
===================================================================
--- palm/trunk/UTIL/Makefile_utilities	(revision 3533)
+++ palm/trunk/UTIL/Makefile_utilities	(revision 3534)
@@ -23,4 +23,7 @@
 # -----------------
 # $Id$
+# inifor build added
+# 
+# 3523 2018-11-13 16:09:31Z suehring
 # Enable compilation of post-processing tool for surface output - interface
 # for posix conform sytemcalls is implemented.
@@ -66,4 +69,16 @@
 PROG3 =  agent_preprocessing
 PROG4 =  surface_output_to_vtk
+PROG5 =  inifor
+
+SOURCES5 = \
+ inifor.f90 \
+ inifor_control.f90 \
+ inifor_defs.f90 \
+ inifor_grid.f90 \
+ inifor_io.f90 \
+ inifor_transform.f90 \
+ inifor_types.f90 \
+ inifor_util.f90
+
 
 OBJS1 =  combine_plot_fields.o
@@ -71,4 +86,5 @@
 OBJS3 =  agent_preprocessing.o
 OBJS4 =  surface_output_to_vtk.o
+OBJS5=$(SOURCES5:.f90=.o)
 
 CC = cc
@@ -84,5 +100,5 @@
 
 
-all: $(PROG1) $(PROG2) $(PROG3) $(PROG4)
+all: $(PROG1) $(PROG2) $(PROG3) $(PROG4) $(PROG5)
 
 $(PROG1): $(OBJS1)
@@ -98,6 +114,40 @@
 	$(F90_SER) -o $(PROG4) $(OBJS4) $(LDFLAGS)
 
+$(PROG5): $(OBJS5)
+	$(F90_SER) -o $(PROG5) $(OBJS5) $(LDFLAGS)
+
 .f90.o:
 	$(F90_SER) $(F90FLAGS) $(COPT) -c $<
 
 
+inifor.o: \
+ inifor_control.o \
+ inifor_defs.o \
+ inifor_grid.o \
+ inifor_io.o \
+ inifor_transform.o \
+ inifor_types.o
+inifor_control.o: \
+ inifor_defs.o \
+ inifor_util.o
+inifor_grid.o: \
+ inifor_control.o \
+ inifor_defs.o \
+ inifor_io.o \
+ inifor_transform.o \
+ inifor_types.o \
+ inifor_util.o
+inifor_io.o: \
+ inifor_control.o \
+ inifor_defs.o \
+ inifor_types.o \
+ inifor_util.o
+inifor_transform.o: \
+ inifor_control.o \
+ inifor_defs.o \
+ inifor_types.o \
+ inifor_util.o
+inifor_types.o: \
+ inifor_defs.o
+inifor_util.o: \
+ inifor_types.o
Index: palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3533)
+++ palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3534)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! NEW_LINE intrinsic replaced by ACHAR to avoid compile time error
+! 
+! 3456 2018-10-30 14:29:54Z eckhard
 ! Bumped version number
 ! 
@@ -100,5 +103,5 @@
  CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.1'            !< INIFOR version number
  CHARACTER(LEN=*), PARAMETER ::  COPYRIGHT = 'Copyright 2017-2018 Leibniz Universitaet Hannover' // &
-     NEW_LINE(' ') // ' Copyright 2017-2018 Deutscher Wetterdienst Offenbach' !< Copyright notice
+     ACHAR( 10 ) // ' Copyright 2017-2018 Deutscher Wetterdienst Offenbach' !< Copyright notice
 
  END MODULE defs
Index: palm/trunk/UTIL/inifor/src/inifor_io.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3533)
+++ palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3534)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! bugfix: INTENT attribute changed
+! 
+! 3456 2018-10-30 14:29:54Z eckhard
 ! NetCDf output of internal arrays only with --debug option 
 ! 
@@ -172,6 +175,6 @@
     SUBROUTINE get_input_dimensions(in_var, ncid)
 
-       TYPE(nc_var), INTENT(INOUT)     ::  in_var
-       INTEGER, INTENT(OUT)            ::  ncid
+       TYPE(nc_var), INTENT(INOUT) ::  in_var
+       INTEGER, INTENT(IN)         ::  ncid
 
        INTEGER ::  i
Index: palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3533)
+++ palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3534)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! bugfix: working precision added
+! 
+! 3447 2018-10-29 15:52:54Z eckhard
 ! Renamed source files for compatibilty with PALM build system
 ! 
@@ -348,5 +351,5 @@
 
        p(1) = constant_density_pressure(p(k_min), zk, rhok, drhodz,            &
-                                        0.0, G)
+                                        0.0_dp, G)
 
     END SUBROUTINE get_surface_pressure